import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

import unittest
import CPSSkinsTestCase
from Testing import ZopeTestCase

class TestPortalThemesTool(CPSSkinsTestCase.CPSSkinsTestCase):

    def afterSetUp(self):
        self.portal.REQUEST.SESSION = {}

    def test_1(self):
        portal = self.portal
        tmtool = portal.portal_themes
        self.assertEquals(tmtool.meta_type, 'Portal Themes Tool')

    def test_2(self):
        tmtool = self.portal.portal_themes
        tmtool.rebuild()

    def test_3(self):
        tmtool = self.portal.portal_themes
        tmtool.setDefaultTheme('empty')
        self.assertEquals(tmtool['theme1']['default'], 0)
        self.assertEquals(tmtool['empty']['default'], 1)

    def test_4(self):
        tmtool = self.portal.portal_themes
        tmtool.setDefaultTheme('theme1')
        self.assertEquals(tmtool['theme1']['default'], 1)
        self.assertEquals(tmtool['empty']['default'], 0)

        tmtool.setDefaultTheme('empty')
        self.assertEquals(tmtool.getDefaultThemeName(), 'empty')

        tmtool.setDefaultTheme('theme1')
        self.assertEquals(tmtool.getDefaultThemeName(), 'theme1')
            
    def test_5(self):
        tmtool = self.portal.portal_themes
        theme = tmtool['theme1']
        for obj in theme.objectValues():
           self.assertEquals(tmtool.getPortalThemeRoot(object=obj), tmtool['theme1'])

    def test_6(self):
        tmtool = self.portal.portal_themes
        self.failUnless('empty' not in tmtool.getGlobalThemes())
        self.failUnless('theme1' not in tmtool.getGlobalThemes())

    def test_7(self):
        tmtool = self.portal.portal_themes
        for themeid in ['theme1', 'empty']:
           self.assertEquals(tmtool.getThemeContainer(theme=themeid).getId(), themeid)
    
    def test_8(self):
        tmtool = self.portal.portal_themes
        self.assertEquals(tmtool.getThemeContainer(parent=1), tmtool)

    def test_9(self):
        tmtool = self.portal.portal_themes
        self.assertEquals([p.getId() for p in tmtool.getPageBlocks(theme='theme1')], ['main', 'pageblock1'])
        self.assertEquals([p.getId() for p in tmtool.getPageBlocks(theme='empty')], [])

    def test_10(self):
        tmtool = self.portal.portal_themes
        theme = tmtool['theme1']
        for obj in theme.objectValues():
           self.assertEquals(tmtool.findStylesByContext(category='Area Color', object=obj)['title'], \
               ['AreaColor4', 'AreaColor1', 'AreaColor2', 'AreaColor3', 'AreaColor5'])
           self.assertEquals(tmtool.findStylesByContext(category='Area Shape', object=obj)['title'], \
               ['AreaShape1', 'AreaShape2'])
           self.assertEquals(tmtool.findStylesByContext(category='Portal Box Color', object=obj)['title'], \
               ['PortalBoxColor2'])
           self.assertEquals(tmtool.findStylesByContext(category='Portal Box Shape', object=obj)['title'], \
               ['PortalBoxShape1'])
           self.assertEquals(tmtool.findStylesByContext(category='Font Color', object=obj)['title'], \
               ['FontColor1', 'FontColor2'])
           self.assertEquals(tmtool.findStylesByContext(category='Font Shape', object=obj)['title'], \
                ['FontShape1'])

    def test_11(self):
        tmtool = self.portal.portal_themes
        theme = tmtool['theme1']
        for obj in theme.objectValues():
           self.assertEquals(tmtool.listPalettes(category='Palette Color', object=obj)['title'], \
               ['PaletteColor1', 'PaletteColor2'])
           self.assertEquals(tmtool.listPalettes(category='Palette Border', object=obj)['title'], \
               ['PaletteBorder1', 'PaletteBorder2'])

    def test_12(self):
        tmtool = self.portal.portal_themes
        for theme in tmtool.getGlobalThemes():
            tmtool.setDefaultTheme(theme)
            self.assert_(self.portal.index_html())
        

def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(TestPortalThemesTool))
    return suite
    
if __name__ == '__main__':
    framework(descriptions=1, verbosity=2)

